SystemOrganization addCategory: #'SomethingIt-Core-Process'!
SystemOrganization addCategory: #'SomethingIt-Core-Data'!
SystemOrganization addCategory: #'SomethingIt-Core-Utilities'!
SystemOrganization addCategory: #'SomethingIt-Core-Tests'!

Morph subclass: #SINotifier
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-Core-Utilities'!

!SINotifier class methodsFor: 'utilities' stamp: 'TO 9/12/2012 11:23'!
notify: aString 
	"SINotifier notify: 'abc'"
	"SINotifier notify: (SINotifier class compiledMethodAt: #notify:)
	getSource"
	^ self new
		in: [:notifier | 
			| text button window |
			notifier changeProportionalLayout.
			text := aString asText asMorph.
			button := SimpleButtonMorph newWithLabel: 'close'.
			button color: Color lightGray muchLighter.
			notifier extent: text bounds width + 10 @ (text bounds height + button bounds height + 10).
			notifier
				addMorph: text
				fullFrame: (LayoutFrame
						fractions: (0 @ 0 corner: 1 @ 1)
						offsets: (0 @ 0 corner: 0 @ button bounds height negated)).
			notifier
				addMorph: button
				fullFrame: (LayoutFrame
						fractions: (0 @ 1 corner: 1 @ 1)
						offsets: (0 @ button bounds height negated corner: 0 @ 0)).
			window := notifier openInWindowLabeled: 'Notifier'.
			button
				on: #mouseUp
				send: #delete
				to: window.
			window position: ActiveHand position - (text bounds width // 2 @ (notifier height - (button bounds height // 2)))]! !

Object variableSubclass: #SIAlgebraicData
	instanceVariableNames: 'constructor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-Core-Data'!

!SIAlgebraicData class methodsFor: 'instance creation' stamp: 'TO 7/25/2012 11:04'!
of: aString
	| value |
	value := self new.
	value setConstructor: aString.
	^ value! !

!SIAlgebraicData class methodsFor: 'instance creation' stamp: 'TO 10/18/2012 11:10'!
of: aString with: anObject 
	| value |
	value := self new: 1.
	value setConstructor: aString.
	value at: 1 put: anObject.
	^ value! !

!SIAlgebraicData class methodsFor: 'instance creation' stamp: 'TO 10/18/2012 11:10'!
of: aString with: object1 with: object2
	| value |
	value := self new: 2.
	value setConstructor: aString.
	value at: 1 put: object1.
	value at: 2 put: object2.
	^ value! !

!SIAlgebraicData class methodsFor: 'instance creation' stamp: 'TO 10/18/2012 11:10'!
of: aString with: object1 with: object2 with: object3 
	| value |
	value := self new: 3.
	value setConstructor: aString.
	value at: 1 put: object1.
	value at: 2 put: object2.
	value at: 3 put: object3.
	^ value! !

!SIAlgebraicData class methodsFor: 'instance creation' stamp: 'TO 10/18/2012 11:11'!
of: aString with: object1 with: object2 with: object3 with: object4
	| value |
	value := self new: 3.
	value setConstructor: aString.
	value at: 1 put: object1.
	value at: 2 put: object2.
	value at: 3 put: object3.
	value at: 4 put: object4.
	^ value! !

!SIAlgebraicData class methodsFor: 'instance creation' stamp: 'TO 7/25/2012 11:05'!
of: aString withAll: anArray 
	| value |
	value := self new: anArray size.
	value setConstructor: aString.
	1
		to: anArray size
		do: [:index | value
				at: index
				put: (anArray at: index)].
	^ value! !

!SIAlgebraicData methodsFor: 'comparing' stamp: 'TO 7/25/2012 12:02'!
= anObject
	(self class == anObject class and: [constructor = anObject constructor and: [self size =  anObject size]]) ifFalse: [^false ].
	1 to: self size do: [ :index |
		(self at: index) = (anObject at: index) ifFalse: [ ^false ]].
	^true! !

!SIAlgebraicData methodsFor: 'accessing' stamp: 'TO 7/25/2012 13:18'!
args
	^ Array withAll: self! !

!SIAlgebraicData methodsFor: 'accessing' stamp: 'TomohiroOda 6/7/2012 14:01'!
constructor
	^ constructor! !

!SIAlgebraicData methodsFor: 'comparing' stamp: 'TO 7/25/2012 12:00'!
hash
	| hash |

	hash := constructor hash.
	1 to: self size do: [:i | hash := (hash + (self at: i) hash) hashMultiply].
	^hash! !

!SIAlgebraicData methodsFor: 'printing' stamp: 'TO 7/25/2012 14:06'!
printOn: aStream 
	aStream nextPutAll: constructor.
	self size = 0
		ifTrue: [^ self].
	aStream nextPut: Character space.
	(self at: 1)
		printOn: aStream.
	2
		to: self size
		do: [:index | 
			aStream nextPut: Character space.
			(self at: index)
				printOn: aStream]! !

!SIAlgebraicData methodsFor: 'private' stamp: 'TO 7/25/2012 10:59'!
setConstructor: aString
	constructor := aString! !

!SIAlgebraicData methodsFor: 'printing' stamp: 'TO 7/25/2012 11:03'!
storeOn: aStream 
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' of: '.
	constructor storeOn: aStream.
	aStream nextPutAll: ' withAll: {'.
	(self at: 1)
		storeOn: aStream.
	2
		to: self size
		do: [:index | 
			aStream nextPutAll: ' . '.
			(self at: index)
				storeOn: aStream].
	aStream nextPut: $}! !

Object subclass: #SIExpressionData
	instanceVariableNames: 'expression environment isLazy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-Core-Data'!

!SIExpressionData class methodsFor: 'examples' stamp: 'TomohiroOda 9/11/2012 15:37'!
exampleHead
	"SIExpressionData exampleHead inspect"

	| head value |
	head := SIExpressionData with: 'head' in: SIHaskell prelude.
	value := head value: #(1 2 3) asOrderedCollection.
	^ Array with: head with: value! !

!SIExpressionData class methodsFor: 'examples' stamp: 'TomohiroOda 9/11/2012 15:45'!
exampleInfiniteList
	"SIExpressionData exampleInfiniteList inspect"

	| take five list |
	take := SIExpressionData with: 'take' in: SIHaskell prelude.
	five := 5.
	list := SIExpressionData with: '[x * 2 | x <- [1..]]' in: take environment.
	^ Array
		with: take
		with: five
		with: list
		with: (take value: five value: list)! !

!SIExpressionData class methodsFor: 'examples' stamp: 'TomohiroOda 9/11/2012 15:37'!
exampleTake
	"SIExpressionData exampleTake inspect"

	| take take2 |
	take := SIExpressionData with: 'take' in: SIHaskell prelude.
	take2 := take value: 2.
	^ Array with: take with: take2 with: (take2 value: #(4 4 1) asOrderedCollection)! !

!SIExpressionData class methodsFor: 'instance creation' stamp: 'TO 9/12/2012 12:22'!
with: aString 
	^ self with: aString in: SIHaskell prelude! !

!SIExpressionData class methodsFor: 'instance creation' stamp: 'TomohiroOda 9/11/2012 11:34'!
with: aString in: anSIExternalInterpreter
	^ (self new)
		expression: aString;
		environment: anSIExternalInterpreter;
		yourself! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:33'!
eagerValue: anArgument 
	^ (self lazyValue: anArgument) value! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:34'!
eagerValue: arg1 value: arg2 
	^ (self lazyValue: arg1 value: arg2) value! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:34'!
eagerValue: arg1 value: arg2 value: arg3 
	^ (self
		lazyValue: arg1
		value: arg2
		value: arg3) value! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:34'!
eagerValueWithArguments: anArray 
	^ (self class
		with: (environment printFunc: expression arguments: anArray)
		in: environment) value! !

!SIExpressionData methodsFor: 'accessing' stamp: 'TomohiroOda 9/11/2012 11:35'!
environment
	^ environment! !

!SIExpressionData methodsFor: 'accessing' stamp: 'TomohiroOda 9/11/2012 11:35'!
environment: anSIExternalInterpreter
	environment := anSIExternalInterpreter! !

!SIExpressionData methodsFor: 'accessing' stamp: 'TomohiroOda 9/11/2012 11:33'!
expression
	^ expression! !

!SIExpressionData methodsFor: 'accessing' stamp: 'TomohiroOda 9/11/2012 11:35'!
expression: aString
	expression := aString! !

!SIExpressionData methodsFor: 'initialize-release' stamp: 'TO 10/17/2012 13:28'!
initialize
	super initialize.
	isLazy := false! !

!SIExpressionData methodsFor: 'accessing' stamp: 'TO 9/21/2012 07:35'!
isLazy
	^ isLazy = true! !

!SIExpressionData methodsFor: 'accessing' stamp: 'TO 9/21/2012 07:35'!
isLazy: aBoolean 
	isLazy := aBoolean = true! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:39'!
lazyValue: anArgument 
	^ (self class
		with: (environment
				printFunc: expression
				arguments: (Array with: anArgument))
		in: environment) isLazy: isLazy;
		 yourself! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:40'!
lazyValue: arg1 value: arg2 
	^ (self class
		with: (environment
				printFunc: expression
				arguments: (Array with: arg1 with: arg2))
		in: environment) isLazy: isLazy;
		 yourself! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:40'!
lazyValue: arg1 value: arg2 value: arg3 
	^ (self class
		with: (environment
				printFunc: expression
				arguments: (Array
						with: arg1
						with: arg2
						with: arg3))
		in: environment) isLazy: isLazy;
		 yourself! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:41'!
lazyValueWithArguments: anArray 
	^ (self class
		with: (environment printFunc: expression arguments: anArray)
		in: environment) isLazy: isLazy;
		 value! !

!SIExpressionData methodsFor: 'printing' stamp: 'TomohiroOda 9/11/2012 15:38'!
printOn: aStream
	aStream nextPut: $<.
	aStream nextPutAll: expression.
	aStream nextPut: $>! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:42'!
value
	^ (environment evaluate: expression)
		in: [:value | 
			(value isKindOf: self class)
				ifTrue: [value isLazy: isLazy].
			value]! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:36'!
value: anArgument 
	^ isLazy
		ifTrue: [self lazyValue: anArgument]
		ifFalse: [self eagerValue: anArgument]! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:37'!
value: arg1 value: arg2 
	^ isLazy
		ifTrue: [self lazyValue: arg1 value: arg2]
		ifFalse: [self eagerValue: arg1 value: arg2]! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:37'!
value: arg1 value: arg2 value: arg3 
	^ isLazy
		ifTrue: [self
				lazyValue: arg1
				value: arg2
				value: arg3]
		ifFalse: [self
				eagerValue: arg1
				value: arg2
				value: arg3]! !

!SIExpressionData methodsFor: 'evaluating' stamp: 'TO 9/21/2012 07:37'!
valueWithArguments: anArray 
	^ isLazy
		ifTrue: [self lazyValueWithArguments: anArray]
		ifFalse: [self eagerValueWithArguments: anArray]! !

Object subclass: #SIExpressionPrinter
	instanceVariableNames: 'classMap extraClassMap escapeMap interpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-Core-Process'!

!SIExpressionPrinter class methodsFor: 'instance creation' stamp: 'TO 9/13/2012 12:45'!
for: anSIExternalInterpreter 
	^ self new interpreter: anSIExternalInterpreter;
		 yourself! !

!SIExpressionPrinter methodsFor: 'adding' stamp: 'TO 10/18/2012 11:30'!
addClassMap: aClassName to: twoArgumentBlock 
	^ extraClassMap add: aClassName asSymbol -> twoArgumentBlock! !

!SIExpressionPrinter methodsFor: 'defaults' stamp: 'TO 9/13/2012 12:39'!
defaultClassMap
	| map |
	map := Array new writeStream.
	map nextPut: #Array -> #printTuple:on:.
	map nextPut: #OrderedCollection -> #printList:on:.
	map nextPut: #Number -> #printNumber:on:.
	map nextPut: #String -> #printString:on:.
	map nextPut: #Character -> #printCharacter:on:.
	map nextPut: #Boolean -> #printBoolean:on:.
	^ map contents! !

!SIExpressionPrinter methodsFor: 'defaults' stamp: 'TO 7/25/2012 14:50'!
defaultEscapeMap
	^ Dictionary new
		at: (Character value: 0)
		put: $0;
		
		at: (Character value: 7)
		put: $a;
		
		at: (Character value: 8)
		put: $b;
		
		at: (Character value: 12)
		put: $f;
		 at: Character lf put: $n;
		 at: Character cr put: $r;
		 at: Character tab put: $t;
		
		at: (Character value: 11)
		put: $v;
		 at: $\ put: $\;
		 at: $" put: $";
		 yourself! !

!SIExpressionPrinter methodsFor: 'initialize-release' stamp: 'TO 10/18/2012 11:29'!
initialize
	super initialize.
	classMap := self defaultClassMap.
	escapeMap := self defaultEscapeMap.
	extraClassMap := OrderedCollection new! !

!SIExpressionPrinter methodsFor: 'defaults' stamp: 'TO 9/13/2012 12:46'!
interpreter
	^ interpreter! !

!SIExpressionPrinter methodsFor: 'defaults' stamp: 'TO 9/13/2012 12:46'!
interpreter: anSIExternalInterpreter 
	interpreter := anSIExternalInterpreter! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 14:52'!
print: anObject 
	| stream |
	stream := String new writeStream.
	self print: anObject on: stream.
	^ stream contents! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 10/18/2012 11:31'!
print: anObject on: aStream 
	classMap
		do: [:maplet | (anObject
					isKindOf: (Smalltalk at: maplet key))
				ifTrue: [^ self
						perform: maplet value
						withArguments: (Array with: anObject with: aStream)]].
	extraClassMap
		do: [:maplet | (anObject
					isKindOf: (Smalltalk at: maplet key))
				ifTrue: [^ maplet value value: anObject value: aStream]].
	^ self printObject: anObject on: aStream! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 14:52'!
printBoolean: anObject on: aStream 
	aStream
		nextPutAll: (anObject == true
				ifTrue: ['True']
				ifFalse: ['False'])! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 14:52'!
printCharacter: aCharacter on: aStream 
	aStream nextPut: $'.
	(escapeMap
		at: aCharacter
		ifAbsent: [])
		ifNotNilDo: [:escape | 
			aStream nextPut: $\.
			aStream nextPut: escape]
		ifNil: [aStream nextPut: aCharacter].
	aStream nextPut: $'! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/27/2012 17:34'!
printFunc: aString arguments: anArray
	| stream |
	stream := String new writeStream.
	self printFunc: aString arguments: anArray on: stream.
	^ stream contents! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/27/2012 17:34'!
printFunc: aString arguments: anArray on: aStream
	^ self subclassResponsibility! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 15:18'!
printList: anObject on: aStream 
	aStream nextPut: $[.
	anObject
		do: [:member | self print: member on: aStream]
		separatedBy: [aStream nextPut: $,].
	aStream nextPut: $] ! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 14:53'!
printNumber: anObject on: aStream 
	anObject printOn: aStream! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 9/13/2012 13:02'!
printObject: anObject on: aStream
	^ self subclassResponsibility! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 14:53'!
printString: anObject on: aStream 
	aStream nextPut: $".
	anObject
		do: [:char | (escapeMap
				at: char
				ifAbsent: [])
				ifNotNilDo: [:escape | 
					aStream nextPut: $\.
					aStream nextPut: escape]
				ifNil: [aStream nextPut: char]].
	aStream nextPut: $"! !

!SIExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 15:19'!
printTuple: anObject on: aStream 
	aStream nextPut: $(.
	anObject
		do: [:member | self print: member on: aStream]
		separatedBy: [aStream nextPut: $,].
	aStream nextPut: $)! !

Object subclass: #SIExternalInterpreter
	instanceVariableNames: 'random process reader writer error semaphore printer parser activationRecord'
	classVariableNames: 'Registry'
	poolDictionaries: ''
	category: 'SomethingIt-Core-Process'!

!SIExternalInterpreter class methodsFor: 'examples' stamp: 'TO 7/26/2012 12:16'!
exampleFizzbuzz: anInteger 
	"SIExternalInterpreter exampleFizzbuzz: 6"
	"SIExternalInterpreter exampleFizzbuzz: 20"
	"SIExternalInterpreter exampleFizzbuzz: 30"
	"SIExternalInterpreter exampleFizzbuzz: 43"
	| haskell vdm fizz buzz fizzbuzz |
	haskell := SIHaskell prelude.
	vdm := SIVDM new.
	SIFileUtils
		temporaryFile: 'SureImprev-fizzbuzz-'
		randomSuffixSize: 8
		suffix: '.hs'
		do: [:hFilename :hStream | 
			hStream nextPutAll: 'fizz x = if mod x 3 == 0 then "fizz" else ""';
				 lf;
				 close.
			haskell
				load: (hFilename copyFrom: 1 to: hFilename size - 3).
			SIFileUtils
				temporaryFile: 'SureImprev-fizzbuzz-'
				randomSuffixSize: 8
				suffix: '.vdm'
				do: [:vFilename :vStream | 
					vStream nextPutAll: 'functions';
						 lf.
					vStream nextPutAll: '  buzz : int -> seq of char';
						 lf.
					vStream nextPutAll: '  buzz(x) == if x mod 5 = 0 then "buzz" else ""';
						 lf.
					vStream close.
					vdm load: vFilename.
					fizz := haskell evaluate: 'fizz ' , anInteger printString.
					haskell close.
					buzz := vdm evaluate: 'buzz(' , anInteger printString , ')'.
					vdm close.
					fizzbuzz := fizz
								, (String withAll: buzz).
					fizzbuzz isEmpty
						ifTrue: [fizzbuzz := anInteger printString]]].
	^ fizzbuzz! !

!SIExternalInterpreter class methodsFor: 'class initialization' stamp: 'TO 10/18/2012 14:22'!
initialize
	super initialize.
	Smalltalk addToShutDownList: self! !

!SIExternalInterpreter class methodsFor: 'registry' stamp: 'TO 7/27/2012 13:21'!
register: anSIExternalInterpreter
	^self registry add: anSIExternalInterpreter! !

!SIExternalInterpreter class methodsFor: 'registry' stamp: 'TO 7/27/2012 13:20'!
registry
	^Registry ifNil: [Registry := WeakRegistry new]
! !

!SIExternalInterpreter class methodsFor: 'other' stamp: 'TO 10/18/2012 14:21'!
shutDown
	self registry
		do: [:interpreter | interpreter basicClose].
	self registry removeAll.
	super shutDown! !

!SIExternalInterpreter class methodsFor: 'registry' stamp: 'TO 7/27/2012 13:21'!
unregister: anSIExternalInterpreter
	^self registry remove: anSIExternalInterpreter ifAbsent:[]! !

!SIExternalInterpreter methodsFor: 'activation record' stamp: 'TO 9/13/2012 13:04'!
activationRecord
	^ activationRecord! !

!SIExternalInterpreter methodsFor: 'private' stamp: 'TO 10/18/2012 08:59'!
basicClose
	process
		ifNotNilDo: [:p | 
			process := nil.
			p sigterm.
			p sigkill].
	reader
		ifNotNilDo: [:r | 
			reader := nil.
			r close].
	writer
		ifNotNilDo: [:w | 
			writer := nil.
			w close]! !

!SIExternalInterpreter methodsFor: 'communicating' stamp: 'TO 9/14/2012 08:19'!
callback: anObject 
	^ self subclassResponsibility! !

!SIExternalInterpreter methodsFor: 'accessing' stamp: 'TO 10/17/2012 11:35'!
callbackToken
	^ $!!! !

!SIExternalInterpreter methodsFor: 'accessing' stamp: 'TO 7/27/2012 13:24'!
close
	self basicClose.
	self unregister! !

!SIExternalInterpreter methodsFor: 'processing' stamp: 'TO 7/26/2012 13:17'!
critical: aBlock 
	^ semaphore critical: aBlock! !

!SIExternalInterpreter methodsFor: 'processing' stamp: 'TO 10/17/2012 13:31'!
evaluate: aString 
	^ self
		evaluate: aString
		ifError: [:msg | 
			SINotifier notify: msg.
			nil]! !

!SIExternalInterpreter methodsFor: 'processing' stamp: 'TO 10/17/2012 13:27'!
evaluate: aString ifError: errorBlock 
	^ self parser
		parse: (self
				plainEvaluate: aString
				ifError: [:msg | ^ errorBlock value: msg])! !

!SIExternalInterpreter methodsFor: 'communicating' stamp: 'tomooda 10/30/2012 14:58'!
expression: aString ifError: errorReceivingBlock 
	^ self subclassResponsibility! !

!SIExternalInterpreter methodsFor: 'class access' stamp: 'TomohiroOda 7/19/2012 12:58'!
expressionParserClass
	^ self subclassResponsibility! !

!SIExternalInterpreter methodsFor: 'class access' stamp: 'TO 7/27/2012 17:31'!
expressionPrinterClass
	^ self subclassResponsibility! !

!SIExternalInterpreter methodsFor: 'finalization' stamp: 'TO 7/27/2012 13:21'!
finalize
	self close! !

!SIExternalInterpreter methodsFor: 'private' stamp: 'TomohiroOda 7/19/2012 13:00'!
forkProcess: descriptors
	^ self subclassResponsibility! !

!SIExternalInterpreter methodsFor: 'initialize-release' stamp: 'TO 9/13/2012 12:53'!
initialize
	super initialize.
	random := Random new.
	semaphore := Semaphore forMutualExclusion.
	activationRecord := OrderedCollection new! !

!SIExternalInterpreter methodsFor: 'parsing and printing' stamp: 'TO 9/13/2012 12:50'!
parse: anObject
	^ self parser parse: anObject! !

!SIExternalInterpreter methodsFor: 'accessing' stamp: 'TO 9/13/2012 12:51'!
parser
	^ parser
		ifNil: [parser := self expressionParserClass for: self]! !

!SIExternalInterpreter methodsFor: 'processing' stamp: 'tomooda 10/30/2012 14:59'!
plainEvaluate: aString 
	^ self
		plainEvaluate: aString
		limit: nil
		ifError: [:msg | 
			SINotifier notify: msg.
			'']! !

!SIExternalInterpreter methodsFor: 'processing' stamp: 'TO 10/17/2012 13:00'!
plainEvaluate: aString ifError: errorBlock 
	^ self
		plainEvaluate: aString
		limit: nil
		ifError: errorBlock! !

!SIExternalInterpreter methodsFor: 'processing' stamp: 'TO 10/17/2012 13:00'!
plainEvaluate: aString limit: anInteger 
	^ self
		plainEvaluate: aString
		limit: anInteger
		ifError: [:msg | 
			SINotifier notify: msg.
			'']! !

!SIExternalInterpreter methodsFor: 'processing' stamp: 'tomooda 10/30/2012 15:00'!
plainEvaluate: aString limit: anInteger ifError: errorBlock 
	^ self
		critical: [process
				ifNil: [self startupProcess].
			self send: aString.
			self
				expression: (self readUpToPromptLimit: anInteger)
				ifError: errorBlock]! !

!SIExternalInterpreter methodsFor: 'parsing and printing' stamp: 'TO 9/13/2012 12:52'!
print: anObject
	^ self printer print: anObject! !

!SIExternalInterpreter methodsFor: 'parsing and printing' stamp: 'TO 9/13/2012 12:52'!
printFunc: aString arguments: anArray
	^ self printer printFunc: aString arguments: anArray! !

!SIExternalInterpreter methodsFor: 'accessing' stamp: 'TO 9/13/2012 12:51'!
printer
	^ printer
		ifNil: [printer := self expressionPrinterClass for: self]! !

!SIExternalInterpreter methodsFor: 'communicating' stamp: 'tomooda 11/1/2012 12:05'!
readUpToPrompt
	| lfStream crStream |
	[reader peek = $!!]
		whileTrue: [| line |
			reader next.
			line := reader upTo: Character lf.
			self
				send: (self printer
						print: (self
								callback: (self parser parse: line)))].
	lfStream := String new writeStream.
	[| chunk |
	chunk := reader upTo: $>.
	lfStream nextPutAll: chunk.
	chunk size <= 1
		or: [(chunk at: chunk size - 1)
				= Character lf]] whileFalse.
	crStream := String new writeStream.
	lfStream contents
		linesDo: [:line | 
			crStream nextPutAll: line.
			crStream cr].
	^ crStream contents! !

!SIExternalInterpreter methodsFor: 'communicating' stamp: 'tomooda 10/31/2012 12:15'!
readUpToPromptLimit: anIntegerOrNil
	| remaining lfStream crStream |
	anIntegerOrNil ifNil: [^self readUpToPrompt ].
	remaining := anIntegerOrNil.
	lfStream := String new writeStream.
	[| chunk |
	chunk := reader upTo: $> limit: remaining.
	lfStream nextPutAll: chunk.
	remaining := remaining - chunk size.
	remaining <= 0 or: [chunk size <= 1
		or: [(chunk at: chunk size - 1)
				= Character lf]]] whileFalse.
	crStream := String new writeStream.
	lfStream contents
		linesDo: [:line | 
			crStream nextPutAll: line.
			crStream cr].
	^ crStream contents! !

!SIExternalInterpreter methodsFor: 'registry' stamp: 'TO 7/27/2012 13:20'!
register
	self class register: self! !

!SIExternalInterpreter methodsFor: 'communicating' stamp: 'TO 10/17/2012 13:41'!
send: aString 
	writer nextPutAll: aString.
	writer nextPut: Character lf.
	writer flush! !

!SIExternalInterpreter methodsFor: 'private' stamp: 'TO 10/18/2012 14:18'!
shutDown
	self close! !

!SIExternalInterpreter methodsFor: 'private' stamp: 'TO 10/18/2012 14:17'!
startUp
	^ self! !

!SIExternalInterpreter methodsFor: 'private' stamp: 'tomooda 10/31/2012 12:25'!
startupProcess
	| pipe1 pipe2 input output desc |
	self basicClose.
	OSProcess accessor canAccessSystem
		ifFalse: [ ^ nil ].
	pipe1 := OSPipe blockingPipe.
	pipe2 := OSPipe blockingPipe.
	input := pipe1 reader.
	output := pipe2 writer.
	writer := pipe1 writer.
	reader := SIPipeInputStream on: pipe2 reader.
	desc := Array with: input with: output with: output.
	process := self forkProcess: desc.
	input close.
	output close.
	self register.
	reader upTo: $>! !

!SIExternalInterpreter methodsFor: 'communicating' stamp: 'tomooda 10/31/2012 11:10'!
trimPrompt: aString 
	| lastIndex |
	lastIndex := aString size.
	[lastIndex > 0
		and: [(aString at: lastIndex)
				= Character cr]]
		whileTrue: [lastIndex := lastIndex - 1].
	(lastIndex > 0
			and: [(aString at: lastIndex)
					= $>])
		ifTrue: [lastIndex := lastIndex - 1].
	(lastIndex > 0
			and: [(aString at: lastIndex)
					= Character cr])
		ifTrue: [lastIndex := lastIndex - 1].
	^ aString copyFrom: 1 to: lastIndex! !

!SIExternalInterpreter methodsFor: 'registry' stamp: 'TO 7/27/2012 13:20'!
unregister
	self class unregister: self! !

Object subclass: #SIFileUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-Core-Utilities'!

!SIFileUtils class methodsFor: 'utilities-suffix' stamp: 'TO 7/26/2012 09:55'!
alphanumericSuffixGenerator
	^ self alphanumericSuffixGenerator: 8! !

!SIFileUtils class methodsFor: 'utilities-suffix' stamp: 'TO 7/26/2012 09:59'!
alphanumericSuffixGenerator: anInteger 
	^ self suffixGeneratorFrom: '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ' copy size: anInteger! !

!SIFileUtils class methodsFor: 'utilities-stream' stamp: 'TO 7/26/2012 09:30'!
appendStream: aString do: aBlock 
	^ FileStream fileNamed: aString asFileName do: [: stream | stream setToEnd. aBlock value: stream]! !

!SIFileUtils class methodsFor: 'utilities-stream' stamp: 'TO 7/26/2012 09:27'!
readStream: aString do: aBlock
	^ FileStream readOnlyFileNamed: aString asFileName do: aBlock! !

!SIFileUtils class methodsFor: 'utilities-suffix' stamp: 'TO 7/26/2012 09:53'!
suffixGeneratorFrom: aString size: anInteger
	| random |
	random := Random new.
	^ [ | suffix | suffix := String new: anInteger. 1 to: anInteger do: [ :index | suffix at: index put: (aString at: (random nextInt: aString size))]. suffix]! !

!SIFileUtils class methodsFor: 'utilities-stream' stamp: 'TO 7/26/2012 10:11'!
temporaryFile: aString randomSuffixSize: anInteger suffix: anotherString do: aTwoArgumentsBlock 
	^ self
		temporaryFile: aString
		suffixGeneratedBy: (self alphanumericSuffixGenerator: anInteger)
		suffix: anotherString
		do: aTwoArgumentsBlock! !

!SIFileUtils class methodsFor: 'utilities-stream' stamp: 'tomooda 10/30/2012 13:32'!
temporaryFile: aString suffixGeneratedBy: aZeroArgumentBlock suffix: anotherString do: aTwoArgumentsBlock 
	| filename |
	[filename := aString , aZeroArgumentBlock value asString , anotherString.
	FileStream isAFileNamed: filename] whileTrue.
	^ FileStream
		newFileNamed: filename
		do: [:stream | [aTwoArgumentsBlock
				value: (FileStream fullName: filename)
				value: stream]
				ensure: [stream close.
					FileDirectory
						deleteFilePath: (FileStream fullName: filename)]]! !

!SIFileUtils class methodsFor: 'utilities-stream' stamp: 'TO 7/26/2012 09:29'!
writeStream: aString do: aBlock 
	^ FileStream fileNamed: aString asFileName do: aBlock! !

Object subclass: #SIIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons'
	poolDictionaries: ''
	category: 'SomethingIt-Core-Utilities'!

!SIIcons class methodsFor: 'accessing' stamp: 'tomooda 10/20/2012 03:42'!
haskellItIcon

	^ Icons
		at: #haskellItIcon
		ifAbsentPut: [ self haskellItIconContents ]! !

!SIIcons class methodsFor: 'accessing' stamp: 'tomooda 10/20/2012 03:43'!
haskellItIconContents
^ (Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 6710886 0 0 0 0 0 0 0 0 2644023448 3348732313 3432618393 126717325 3345376870 3345376870 3009766757 0 0 0 0 0 0 0 0 0 546937241 4288256409 4271413400 3046742425 1348427615 4284900966 4284900966 1952802149 0 0 0 0 0 0 0 0 0 2107152536 4288190616 4288256409 1168154784 3211093349 4268123750 4284900966 409232484 6710886 0 0 0 0 0 0 0 0 3684276633 4271479193 4254636184 226130554 4284900966 4268057957 3597035110 0 2107218329 1939446169 1939446169 1939446169 1939446169 1939446169 0 10066329 496539800 4288190616 4271479193 3113785496 1298030174 4284900966 4284835173 1919116131 2543425945 4288256409 4288256409 4288256409 4288256409 4288256409 0 0 0 1956157592 4288256409 4288256409 1352506781 3060098405 4284900966 4284900966 442918502 1939380376 1788451225 1788451225 1788451225 1788451225 0 0 0 2677643673 4288190616 4288190616 648455846 3647300965 4268123750 4268123750 3647300965 67108863 2929301913 2744752537 2744752537 2744752537 0 10000536 1016699289 4288256409 4288190616 2342165146 2070176868 4284900966 4284900966 4284900966 4284900966 1952670563 2459539865 4288190616 4288256409 4288256409 10132122 0 4120418456 4271413400 3902314648 441931607 4284900966 4268123750 2892392038 3009832550 4268123750 4284835173 527001961 999856280 949590425 949590425 0 2795084185 4288256409 4288256409 547726757 3764807270 4268123750 4217726309 57108327 90531173 4251346534 4268123750 3664078181 0 0 0 1066965144 4288256409 4288190616 2291767705 2120508516 4284835173 4284900966 1248224870 5460819 0 1348822373 4284900966 4284835173 2070242661 0 0 2023266456 2342099353 2392365208 0 2472895845 2338743910 1952802149 0 0 0 0 2003199590 2338743910 2456118629 9539985 0 0 0 0 0 0 0 0 6710886 0 0 6645093 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!SIIcons class methodsFor: 'class initialization' stamp: 'tomooda 10/20/2012 03:42'!
initialize
	super initialize.
	Icons := Dictionary new! !

!SIIcons class methodsFor: 'accessing' stamp: 'tomooda 10/20/2012 03:43'!
inspectHaskellItIcon

	^ Icons
		at: #inspectHaskellItIcon
		ifAbsentPut: [ self inspectHaskellItIconContents ]! !

!SIIcons class methodsFor: 'accessing' stamp: 'tomooda 10/20/2012 03:43'!
inspectHaskellItIconContents
^ (Form
	extent: 16@16
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290822336 4289703855 4289572269 4294769916 4287137928 4287137928 4287861651 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294111986 4288256409 4288190616 4290230199 4291677645 4284900966 4284900966 4290361785 4290624696 4287005809 4286215768 4286084179 4286939756 4291019448 4294967295 4294967295 4294967295 4291677645 4288190616 4288256409 4293256677 4287401100 4284572001 4282466095 4289043540 4293122170 4293716386 4293650857 4293057155 4287990854 4285163344 4293388261 4294967295 4294967295 4289177511 4288256409 4288256409 4293717228 4281873961 4292595556 4290889629 4291554559 4290765042 4290830835 4290830835 4291418825 4292595824 4284636739 4294967295 4294967295 4294177779 4288190616 4288256409 4284374618 4291871846 4289969820 4289054424 4290436077 4290567664 4289909733 4289909733 4289055199 4286292401 4291477599 4294967295 4294967295 4294967295 4291875024 4288256409 4283979071 4293583241 4289778147 4289054425 4289054425 4291291387 4290830835 4290896628 4289713387 4284716481 4291547544 4294967295 4294967295 4294967295 4290756543 4287664272 4285623363 4293388208 4289383390 4289054425 4289054425 4289383390 4291554559 4290436077 4288727265 4284585152 4288723114 4294967295 4294967295 4293388263 4288256409 4286874756 4287596886 4291941539 4289054425 4289054425 4289054425 4289054425 4290370285 4290633456 4287345875 4284453566 4288065962 4294967295 4294967295 4288453788 4288190616 4288782753 4285689684 4291478646 4289054425 4289843941 4289778148 4289054425 4289054424 4290042096 4285111237 4284782531 4290956708 4294967295 4290624957 4288256409 4288256409 4294243572 4282532152 4293055848 4289445811 4291554558 4291554558 4288857304 4287214285 4284782014 4284848324 4285373122 4293908086 4293322470 4288256409 4288190616 4291414473 4289901234 4283979864 4282794797 4293582458 4291683291 4287741150 4285045189 4284255930 4284255930 4285242044 4294723633 4294915349 4291809231 4291282887 4291217094 4294967295 4289111718 4289506476 4287927443 4285031754 4292134756 4292730007 4290431656 4289379489 4291546506 4293251433 4294933600 4294950502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4286874489 4285952855 4286281292 4286347082 4286479193 4287268982 4285426515 4294171011 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294769916 4294835709 4294967295 4294967295 4294440951 4285887336)
	offset: 0@0)! !

!SIIcons class methodsFor: 'accessing' stamp: 'tomooda 10/20/2012 03:43'!
itemsIcons
	"answer a collection of associations wordings -> icon to  
	decorate  
	the menus all over the image"
	| icons |
	icons := OrderedCollection new.

	"icons add: #('Test Runner' ) -> self smallTrafficIcon."

	" 
	world menu"
	icons add: #('previous project' 'go to previous project') -> self smallProjectBackIcon.
	icons add: #('go to next project') -> self smallProjectNextIcon.
	icons add: #('select' ) -> self smallSelectIcon.
	icons add: #('jump to project...' ) -> self smallProjectJumpIcon.
	icons add: #('open...' ) -> self smallOpenIcon.
	icons add: #('appearance...' ) -> self smallConfigurationIcon.
	icons add: #('help...' ) -> self smallHelpIcon.
	icons add: #('windows...' ) -> self smallWindowIcon.
	icons add: #('changes...' ) -> self smallChangesIcon.
	icons add: #('print PS to file...' ) -> self smallPrintIcon.
	icons add: #('debug...' ) -> self smallDebugIcon.
	icons add: #('export...' ) -> self smallExportIcon.
	icons add: #('save' ) -> self smallSaveIcon.
	icons add: #('save project on file...' ) -> self smallProjectSaveIcon.
	icons add: #('save as...') -> self smallSaveAsIcon.
	icons add: #('save as new version') -> self smallSaveNewIcon.
	icons add: #('save and quit' ) -> self smallQuitIcon.
	icons add: #('quit') -> self smallQuitNoSaveIcon.
	icons add: #('load project from file...' ) -> self smallProjectLoadIcon.
	""
	icons add: #('do it (d)' ) -> self smallDoItIcon.
	icons add: #('inspect it (i)' 'explore it (I)' 'inspect world' 'explore world' 'inspect model' 'inspect morph' 'explore morph' 'inspect owner chain' 'explore' 'inspect' 'explore (I)' 'inspect (i)' 'basic inspect' ) -> self smallInspectItIcon.
	icons add: #('print it (p)' ) -> self smallPrintIcon.
	icons add: #('debug it' ) -> self smallDebugIcon.
	icons add: #('tally it' ) -> self smallTimerIcon.
	""
	icons add: #('copy (c)' 'copy to paste buffer' 'copy text' ) -> self smallCopyIcon.
	icons add: #('paste (v)' 'paste...' ) -> self smallPasteIcon.
	icons add: #('cut (x)' ) -> self smallCutIcon.
	""
	icons add: #('accept (s)' 'yes' 'Yes' ) -> self smallOkIcon.
	icons add: #('cancel (l)' 'no' 'No' ) -> self smallCancelIcon.
	""
	icons add: #('do again (j)' ) -> self smallRedoIcon.
	icons add: #('undo (z)' ) -> self smallUndoIcon.
	""
	icons add: #( 'find class... (f)' 'find method...' ) -> self smallSearchIcon.
	icons add: #('find...(f)' 'find again (g)') -> self smallFindIcon.
	""
	icons add: #('remove' 'remove class (x)' 'delete method from changeset (d)' 'remove method from system (x)' 'delete class from change set (d)' 'remove class from system (x)' 'destroy change set (X)' ) -> self smallDeleteIcon.
	icons add: #('add item...' 'new category...' 'new change set... (n)' ) -> self smallNewIcon.
	""
	icons add: #('new morph...' 'objects (o)' ) -> self smallObjectCatalogIcon.
	icons add: #('authoring tools...')  -> self smallAuthoringToolsIcon.
	icons add: #('projects...')  -> self smallProjectIcon.
	""
	icons add: #('make screenshot')  -> self smallScreenshotIcon.
	
	""
	icons add: #('leftFlush' ) -> self smallLeftFlushIcon.
	icons add: #('rightFlush' ) -> self smallRightFlushIcon.
	icons add: #('centered' 'set alignment... (u)' ) -> self smallCenteredIcon.
	icons add: #('justified' ) -> self smallJustifiedIcon.
	""
	icons add: #('set font... (k)' 'list font...' 'set subtitles font' 'change font' 'system fonts...' 'change font...' ) -> self smallFontsIcon.
	icons add: #('full screen on') -> self smallFullscreenOnIcon.
	icons add: #('full screen off' ) -> self smallFullscreenOffIcon.
	""
	icons add: #('haskell it (h)') -> self haskellItIcon.
	icons add: #('inspect haskell it (H)') -> self inspectHaskellItIcon.
	^ icons! !

Object subclass: #SIPipeInputStream
	instanceVariableNames: 'stream peek last'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-Core-Process'!

!SIPipeInputStream class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/24/2012 11:47'!
on: aStream
	^ (self new)
		setStream: aStream;
		yourself! !

!SIPipeInputStream methodsFor: 'testing' stamp: 'TO 10/19/2012 10:05'!
atEnd
	^ stream atEnd
		or: [self peek isNil]! !

!SIPipeInputStream methodsFor: 'accessing' stamp: 'TomohiroOda 7/24/2012 11:54'!
close
	stream close! !

!SIPipeInputStream methodsFor: 'accessing' stamp: 'TomohiroOda 7/24/2012 11:56'!
flush
	stream flush! !

!SIPipeInputStream methodsFor: 'accessing' stamp: 'TomohiroOda 7/24/2012 12:06'!
next
	^ last := peek notNil
		ifTrue: [ 
			| char |
			char := peek.
			peek := nil.
			char ]
		ifFalse: [ stream next ]! !

!SIPipeInputStream methodsFor: 'accessing' stamp: 'TomohiroOda 7/24/2012 11:51'!
peek
	^ peek ifNil: [ peek := stream next ]! !

!SIPipeInputStream methodsFor: 'private' stamp: 'TomohiroOda 7/24/2012 11:47'!
setStream: aStream
	stream := aStream! !

!SIPipeInputStream methodsFor: 'accessing' stamp: 'TomohiroOda 9/10/2012 15:44'!
upTo: aCharacter
	| writeBuffer |
	writeBuffer := String new writeStream.
	[ 
	| char |
	self atEnd
		ifTrue: [ ^ writeBuffer contents ].
	char := self next.
	writeBuffer nextPut: char.
	char = aCharacter
		ifTrue: [ ^ writeBuffer contents ] ] repeat! !

!SIPipeInputStream methodsFor: 'accessing' stamp: 'TO 9/21/2012 08:53'!
upTo: aCharacter limit: anInteger 
	| writeBuffer size |
	writeBuffer := String new writeStream.
	size := 0.
	[| char |
	self atEnd
		ifTrue: [^ writeBuffer contents].
	char := self next.
	writeBuffer nextPut: char.
	size := size + 1.
	(char = aCharacter
			or: [size >= anInteger])
		ifTrue: [^ writeBuffer contents]] repeat! !

Object subclass: #SIValueParser
	instanceVariableNames: 'classMap escapeMap algebraicDataMap interpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-Core-Process'!

!SIValueParser class methodsFor: 'instance creation' stamp: 'TO 9/13/2012 12:49'!
for: anSIExternalInterpreter 
	^ self new interpreter: anSIExternalInterpreter;
		 yourself! !

!SIValueParser methodsFor: 'adding' stamp: 'tomooda 11/1/2012 10:50'!
addAlgebraicDataMap: aConstructorName to: twoArgumentBlock 
	^ algebraicDataMap at: aConstructorName put: twoArgumentBlock! !

!SIValueParser methodsFor: 'parsing' stamp: 'tomooda 11/1/2012 11:05'!
constructAlgebraicData: constructorString args: anArray 
	^ (algebraicDataMap
		at: constructorString
		ifAbsent: [[:constructor :args | self defaultAlgebraicDataClass of: constructorString withAll: anArray]])
		value: constructorString
		value: anArray! !

!SIValueParser methodsFor: 'defaults' stamp: 'tomooda 11/1/2012 11:04'!
defaultAlgebraicDataClass
	^ SIAlgebraicData! !

!SIValueParser methodsFor: 'defaults' stamp: 'TO 7/25/2012 11:07'!
defaultClassMap
	^ Dictionary new at: #Tuple put: [:args | Array withAll: args] ;
		 at: #List put: [:args | OrderedCollection withAll: args] ;
		 at: #Set put: [:args | Set withAll: args] ;
		 yourself! !

!SIValueParser methodsFor: 'defaults' stamp: 'TomohiroOda 7/20/2012 10:47'!
defaultEscapeMap
	| readHex readOctal |
	readHex := [ :stream | 
	| code |
	code := 0.
	[ 
	stream atEnd not
		and: [ 
			| index |
			index := #($0 $1 $2 $3 $4 $5 $6 $7 $8 $9 $a $b $c $d $e $f) indexOf: stream peek asLowercase.
			index > 0
				and: [ 
					code := code * 16 + index - 1.
					stream next notNil ] ] ] whileTrue.
	Character value: code ].
	readOctal := [ :stream | 
	| code |
	code := 0.
	[ 
	stream atEnd not
		and: [ 
			| index |
			index := #($0 $1 $2 $3 $4 $5 $6 $7) indexOf: stream peek.
			index > 0
				and: [ 
					code := code * 8 + index - 1.
					stream next notNil ] ] ] whileTrue.
	Character value: code ].
	^ (Dictionary new)
		at: $a put: (Character value: 7);
		at: $b put: (Character value: 8);
		at: $f put: (Character value: 12);
		at: $n put: Character lf;
		at: $r put: Character cr;
		at: $t put: Character tab;
		at: $v put: (Character value: 11);
		at: $e put: (Character value: 27);
		at: $' put: $';
		at: $" put: $";
		at: $\ put: $\;
		at: $x put: readHex;
		at: $c
			put: [ :stream | 
					| code |
					code := stream next asLowercase.
					(code between: $a and: $z)
						ifTrue: [ Character value: code - $a + 1 ]
						ifFalse: [ self error: 'Invalid control format in a String literal' ] ];
		at: $u put: readHex;
		at: $0 put: readOctal;
		at: $1 put: readOctal;
		at: $2 put: readOctal;
		at: $3 put: readOctal;
		at: $4 put: readOctal;
		at: $5 put: readOctal;
		at: $6 put: readOctal;
		at: $7 put: readOctal;
		yourself! !

!SIValueParser methodsFor: 'initialize-release' stamp: 'tomooda 11/1/2012 10:43'!
initialize
	super initialize.
	classMap := self defaultClassMap.
	escapeMap := self defaultEscapeMap.
	algebraicDataMap := Dictionary new! !

!SIValueParser methodsFor: 'accessing' stamp: 'TO 9/13/2012 12:49'!
interpreter
	^ interpreter! !

!SIValueParser methodsFor: 'accessing' stamp: 'TO 9/13/2012 12:49'!
interpreter: anSIExternalInterpreter
	interpreter := anSIExternalInterpreter! !

!SIValueParser methodsFor: 'testing' stamp: 'TomohiroOda 7/20/2012 10:52'!
isIdentifierChar: aCharacter
	^ aCharacter isAlphaNumeric or: [ aCharacter = $_ ]! !

!SIValueParser methodsFor: 'testing' stamp: 'TomohiroOda 7/20/2012 10:52'!
isLowerIdentifierChar: aCharacter
	^ aCharacter isLowercase or: [ aCharacter isDigit or: [ aCharacter = $_ ] ]! !

!SIValueParser methodsFor: 'testing' stamp: 'TO 10/19/2012 08:01'!
isSeparatorChar: aCharacter
	^ aCharacter notNil and: [aCharacter isSeparator or: [aCharacter = Character lf ]]! !

!SIValueParser methodsFor: 'testing' stamp: 'TomohiroOda 7/20/2012 10:52'!
isUpperIdentifierChar: aCharacter
	^ aCharacter isUppercase or: [ aCharacter isDigit or: [ aCharacter = $_ ] ]! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 7/20/2012 10:49'!
parse: aString
	^ self parseStream: aString readStream! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 7/24/2012 12:44'!
parse: aStream accept: aString
	aString
		do: [ :char | 
			aStream peek = char
				ifFalse: [ ^ false ].
			aStream next ].
	^ true! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 9/11/2012 08:52'!
parse: aString ifError: errorBlock
	^ self parseStream: aString readStream ifError: errorBlock! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 7/24/2012 11:00'!
parseCharacter: aReadStream
	| string char quote |
	aReadStream next.
	char := aReadStream next.
	char = $\
		ifTrue: [ 
			| control |
			control := aReadStream next.
			char := escapeMap at: control ifAbsent: [ control ].
			char isCharacter
				ifFalse: [ char := char value: aReadStream ] ].
	quote := aReadStream next.
	quote = $'
		ifFalse: [ ^ self error: 'Unexpected characater : ' , (String with: quote) , ' , here should be a single quote.' ].
	^ char! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 7/20/2012 14:12'!
parseExpressionList: aReadStream separatedBy: aString
	| expressions |
	expressions := Array new writeStream.
	[ 
	expressions nextPut: (self parseStream: aReadStream).
	self parse: aReadStream accept: aString ] whileTrue.
	^ expressions contents! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 7/20/2012 10:52'!
parseIdentifier: aReadStream
	| identifier |
	identifier := String new writeStream.
	[ aReadStream atEnd not and: [ self isIdentifierChar: aReadStream peek ] ]
		whileTrue: [ identifier nextPut: aReadStream next ].
	^ identifier contents! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 7/20/2012 14:08'!
parseInteger: aReadStream
	^ aReadStream peek = $-
		ifTrue: [ 
			aReadStream next.
			(self parseNaturalNumber: aReadStream) * -1 ]
		ifFalse: [ self parseNaturalNumber: aReadStream ]! !

!SIValueParser methodsFor: 'parsing' stamp: 'TO 7/25/2012 12:53'!
parseList: aReadStream 
	| expressions |
	aReadStream next = $[
		ifFalse: [^ self error: 'Invalid expression. Missing $['].
	expressions := aReadStream peek ~= $]
		ifTrue: [self parseExpressionList: aReadStream separatedBy: ',']
		ifFalse: [Array new].
	aReadStream next = $]
		ifFalse: [^ self error: 'Invalid expression. Missing $]'].
	^ (classMap at: #List)
		value: expressions contents! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 7/20/2012 14:07'!
parseNaturalNumber: aReadStream
	| number |
	number := 0.
	[ aReadStream atEnd not and: [ aReadStream peek isDigit ] ]
		whileTrue: [ number := number * 10 + aReadStream next digitValue ].
	^ number! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 8/2/2012 14:19'!
parseNumber: aReadStream
	^ Number readFrom: (self readNumber: aReadStream) asLowercase readStream! !

!SIValueParser methodsFor: 'parsing' stamp: 'TO 10/19/2012 08:02'!
parseStream: aReadStream 
	aReadStream atEnd
		ifTrue: [^ nil].
	^ self
		parseStream: aReadStream
		ifError: [:errorMessage | SINotifier notify: errorMessage]! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 9/10/2012 15:48'!
parseStream: aReadStream ifError: errorBlock
	^ self subclassResponsibility ! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 9/11/2012 10:01'!
parseStream: aReadStream ifSuccess: aBlock ifError: errorBlock
	^ (self parseStream: aReadStream ifError: [ :msg | ^ errorBlock value: msg ]) in: aBlock! !

!SIValueParser methodsFor: 'parsing' stamp: 'TomohiroOda 7/20/2012 11:11'!
parseString: aReadStream
	| string char |
	aReadStream next.
	string := String new writeStream.
	[ (char := aReadStream next) ~= $" ]
		whileTrue: [ 
			char = $\
				ifTrue: [ 
					| control |
					control := aReadStream next.
					char := escapeMap at: control ifAbsent: [ control ].
					char isCharacter ifFalse: [char := char value: aReadStream]  ].
			string nextPut: char ].
	^ string contents! !

!SIValueParser methodsFor: 'parsing' stamp: 'TO 10/17/2012 15:34'!
readNumber: aReadStream 
	| expr char |
	expr := String new writeStream.
	aReadStream atEnd
		ifTrue: [^ self error: 'Unexpected end of stream.'].
	char := aReadStream next.
	(char isDigit
			or: [char = $-])
		ifFalse: [^ self error: 'Invalid number format. Missing digit or sign'].
	expr nextPut: char.
	[aReadStream atEnd not
		and: [aReadStream peek isDigit]]
		whileTrue: [expr nextPut: aReadStream next].
	aReadStream peek = $.
		ifFalse: [^ expr contents].
	expr nextPut: aReadStream next.
	[aReadStream atEnd not
		and: [aReadStream peek isDigit]]
		whileTrue: [expr nextPut: aReadStream next].
	aReadStream atEnd
		ifTrue: [^ expr contents].
	aReadStream peek asLowercase = $e
		ifFalse: [^ expr contents].
	expr nextPut: aReadStream next.
	char := aReadStream next.
	(char isDigit
			or: [char = $-])
		ifFalse: [^ self error: 'Invalid number format. Missing digit or sign'].
	expr nextPut: char.
	[aReadStream atEnd not
		and: [aReadStream peek isDigit]]
		whileTrue: [expr nextPut: aReadStream next].
	^ expr contents! !

!SIValueParser methodsFor: 'parsing' stamp: 'TO 7/25/2012 12:51'!
skipSeparator: aStream
	[self isSeparatorChar: aStream peek] whileTrue: [aStream next]! !

TestCase subclass: #SIAlgebraicDataTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-Core-Tests'!

!SIAlgebraicDataTest methodsFor: 'testing' stamp: 'TO 7/25/2012 14:00'!
testArgs
	self assert: #() equals: (SIAlgebraicData of: 'fure') args.
	self assert: #(4 4 1) equals: (SIAlgebraicData of: 'freq' withAll: #(4 4 1 )) args! !

!SIAlgebraicDataTest methodsFor: 'testing' stamp: 'TO 7/25/2012 14:05'!
testConstructor
	self assert: 'fure' equals: (SIAlgebraicData of: 'fure') constructor.
	self assert: 'freq' equals: (SIAlgebraicData of: 'freq' withAll: #(4 4 1)) constructor.
! !

!SIAlgebraicDataTest methodsFor: 'testing' stamp: 'TO 7/25/2012 14:04'!
testEquals
	self
		assert: (SIAlgebraicData of: 'freq' withAll: #(4 4 1 )) = (SIAlgebraicData of: 'freq' withAll: #(4 4 1 )).
	self deny:  (SIAlgebraicData of: 'Freq' withAll: #(4 4 1 )) = (SIAlgebraicData of: 'freq' withAll: #(4 4 1 )).
	self deny:  (SIAlgebraicData of: 'freq' withAll: #(4 4 1 )) = (SIAlgebraicData of: 'freq' withAll: #(441 )).! !

!SIAlgebraicDataTest methodsFor: 'testing' stamp: 'TO 7/25/2012 14:08'!
testHash
	self assert: (SIAlgebraicData of: 'freq' withAll: #(4 4 1 )) hash
			equals: (SIAlgebraicData of: 'freq' withAll: #(4 4 1 )) hash! !

!SIAlgebraicDataTest methodsFor: 'testing' stamp: 'TO 7/25/2012 14:05'!
testPrintString
	self assert: 'fure' equals: (SIAlgebraicData of: 'fure') printString.
	self assert: 'freq 4 4 1' equals: (SIAlgebraicData of: 'freq' withAll: #(4 4 1 )) printString! !

!SIAlgebraicDataTest methodsFor: 'testing' stamp: 'TO 7/25/2012 14:02'!
testStoreString
	| data |
	data := (SIAlgebraicData of: 'freq' withAll: #(4 4 1 )).
	self assert: data equals: (Compiler evaluate: data storeString).! !
SIExternalInterpreter initialize!
SIIcons initialize!
